#include <DualWheelTruck.h> // Подключение библиотеки <DualWheelTruck.h> для работы с моторами

#define LEFT_LED 6 // Назначение пина, к которому подключен левый светодиод
#define RIGHT_LED 11 // Назначение пина, к которому подключен правый светодиод
#define BUTTON 5 // Назначение пина, к которому подключена тактовая кнопка

bool button_state=true; // Объявление переменной button_state и присвоение ей значения true
bool robot_state=false; // Б.1 - Объявление переменной robot_state и присвоение ей значения false

int speeds=100; // Б.1 - Объявление переменной speeds и присвоение ей значения 100
int counter; // Объявление переменной counter

DCMotor* motor_right; // Инициализация мотора и присвоение ему имени motor_right
DCMotor* motor_left; // Инициализация мотора и присвоение ему имени motor_left

void setup() {
Board::vertor_PCA(); // Объявление типа используемого контроллера - vertor_PCA

motor_right = new DCMotor(1, 0, true, 5); // Настройка мотора motor_right с применением функции DCMotor(a, b, c, d): подключен к клеммнику 1, прямая полярность подключения мотора, инерционность 5
motor_left = new DCMotor(0, 0, false, 5); // Настройка мотора motor_left с применением функции DCMotor(a, b, c, d): подключен к клеммнику 0, обратная полярность подключения мотора, инерционность 5

motor_right->stop(false); // Команда на остановку вращения мотора motor_right
motor_left->stop(false); // Команда на остановку вращения мотора motor_left
 
pinMode (LEFT_LED,OUTPUT); // Настройка пина LEFT_LED на вывод
pinMode (RIGHT_LED,OUTPUT); // Настройка пина RIGHT_LED на вывод
pinMode (BUTTON,INPUT); // Настройка пина BUTTON на ввод
}

void loop() {
button_state=digitalRead(BUTTON); //  Б.2 - Сохранение состояния на пине BUTTON в переменную button_state
if(button_state==false) // Б.3 - Если значение переменной button_state равно false (иначе можно записать 0), то начать выполнение инструкций в скобках 
{
  robot_state=true; // Б.4 - Присвоение переменной robot_state значения true
  counter=0; // Б.5 - Присвоение переменной counter значения 0
  while(counter<3) // Б.6 - Инициализация цикла While()
                   // Б.6 - Выполнение цикла, пока значение переменной counter меньше 3                                     
  {
    digitalWrite(LEFT_LED,HIGH); // Б.7 - Установить на пине LEFT_LED напряжение, соответствующее уровню "HIGH"
    digitalWrite(RIGHT_LED,HIGH); // Б.7 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "HIGH"
    delay(500); // Б.8 - Ожидание 0,5 секунды
    digitalWrite(LEFT_LED,LOW); // Б.9 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
    digitalWrite(RIGHT_LED,LOW); // Б.9 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "LOW"
    delay(500); // Б.10 - Ожидание 0,5 секунд
    counter=counter+1; // Б.11 - Увеличение значения переменной counter на 1
  }
  while(robot_state==true) // Б.12 - Цикл While (). Выполнение цикла до тех пор, пока истинен результат логической операции robot_state==true
  {   
     motor_right->forward(speeds); // Б.13 - Команда на запуск мотора motor_right со скоростью speeds %
     motor_left->forward(speeds); // Б.13 - Команда на запуск мотора motor_left со скоростью speeds %
     delay(150); // Б.14 - Ожидание 0,15 секунд
     motor_left->stop(false); // Б.15 - Команда на остановку вращения мотора motor_left
     delay(600); // Б.16 - Ожидание 0,6 секунд
     motor_left->forward(speeds); // Б.17 - Команда на запуск мотора motor_left со скоростью speeds %
     delay(300); // Б.18 - Ожидание 0,3 секунды
     motor_right->stop(false); // Б.19 - Команда на остановку вращения мотора motor_right     
     delay(1200); // Б.20 - Ожидание 1,2 секунды
     motor_right->forward(speeds); // Б.21 - Команда на запуск мотора motor_right со скоростью speeds %
     delay(800); // Б.22 - Ожидание 0,8 секунд
     motor_left->stop(false); // Б.23 - Команда на остановку вращения мотора motor_left
     delay(1200); // Б.24 - Ожидание 1,2 секунды
     motor_left->forward(speeds); // Б.25 - Команда на запуск мотора motor_left со скоростью speeds %
     delay(300); // Б.26 - Ожидание 0,3 секунды
     motor_right->stop(false); // Б.27 - Команда на остановку вращения мотора motor_right
     delay(600); // Б.28 - Ожидание 0,6 секунд
     motor_left->stop(false); // Б.29 - Команда на остановку вращения мотора motor_left
     
     button_state=digitalRead(BUTTON); // Б.30 - Сохранение состояния на пине BUTTON в переменную button_state
  if(button_state==false) // Б.31 - Если значение переменной button_state равно false, то начать выполнение инструкций в скобках 
  {    
      robot_state=false; // Б.32 - Присвоение переменной robot_state значения false
      delay(2000); // Б.33 - Ожидание 2 секунды
  }  
   }     
}
}
